$if not setglobal debug $offlisting offinclude
$ontext

            XLIMPORT: A Spreadsheet Data Import Utility for GAMS

                     (an interface to XLLINK.EXE)

Usage:

               $LIBINCLUDE XLIMPORT parameter xlfile range

N.B.	Data import occurs at compile time.
	Parameter must be declared with explicit dimension.

$offtext

$if setglobal xl_system $goto countargs
$setglobal xl_system 'operating'
$echo %system.gstring%     >xllink.log
$echo XLLINK Activity Log >>xllink.log
$label countargs

$setlocal param  '%1'
$setlocal xlfile '%2'
$setlocal range  '%3'


$if not a%range% == a  $goto checkfile
$error XLIMPORT arguments mixling xlfile=%xlfile% range=%range% param=%param%
$log *** XLIMPORT incorrect call
$exit

$label checkfile
$if exist %xlfile%  $goto checkparam
$error XLIMPORT spreadsheet file (%xlfile%) is missing.
$log *** XLIMPORT spreadsheet file (%xlfile%) is missing.
$exit

$label checkparam
$if declared %param% $goto start
$error XLIMPORT parameter %param% has not been declared prior to call.
$log *** XLIMPORT parameter %param% has not been declared prior to call.
$exit

$label start

$if dimension 0  %param% $set r '0'
$if dimension 1  %param% $set r '1'
$if dimension 2  %param% $set r '2'
$if dimension 3  %param% $set r '3'
$if dimension 4  %param% $set r '4'
$if dimension 5  %param% $set r '5'
$if dimension 6  %param% $set r '6'
$if dimension 7  %param% $set r '7'
$if dimension 8  %param% $set r '8'
$if dimension 9  %param% $set r '9'
$if dimension 10 %param% $set r '10'


$echo %system.incparent% XLIMPORT %1 %2 %3 %4 >>xllink.log

$echo	%xlfile%		>%gams.scrdir%xlcmd.scr
$echo	%gams.scrdir%xllink.scr	>>%gams.scrdir%xlcmd.scr
$echo	%r%			>>%gams.scrdir%xlcmd.scr
$echo	>>%gams.scrdir%xlcmd.scr
$echo	%range%	>>%gams.scrdir%xlcmd.scr

$log --- Importing "%param%" from spreadsheet "%xlfile%" range "%range%"

*$call '=%gams.sdir%xllink %gams.scrdir%xlcmd.scr xllink.log'
$call 'xllink %gams.scrdir%xlcmd.scr xllink.log'

$onlisting
$if     dimension 0 %param% scalar %param% /
$if not dimension 0 %param% parameter %param% /
$include %gams.scrdir%xllink.scr
/;
